# Use previous extract data from TVStudy cel file to create
# Numpy matrix for processing and display as kmz
# v004 - everything working except overlay map size is wrong in kmz
import numpy as np
import matplotlib as mpl
import matplotlib.colors as col
import matplotlib.cm as cm
import matplotlib.pyplot as plt
from pylab import *
from scipy import mgrid
import simplekml

scale_min = 41
scale_max = 128

long_inc = 0
lat_inc = 0
diff = 0  
  
with open( "cellidx_data.txt", "r") as cellidx_data:
  southidx = int(cellidx_data.readline())
  eastidx = int(cellidx_data.readline())
  northidx = int(cellidx_data.readline())
  westidx = int(cellidx_data.readline())
  cellidx_data.readline()
  data = cellidx_data.readline()
  long_tvidx0 = int(data.split(' ')[1])
  data = cellidx_data.readline()
  long_tvidx1 = int(data.split(' ')[1])
  long_inc = abs(long_tvidx0 - long_tvidx1)
  while diff < 10000:
    data = cellidx_data.readline()
    lat_tvidx0 = int(data.split(' ')[0])
    data = cellidx_data.readline()
    lat_tvidx1 = int(data.split(' ')[0])
    lat_inc = lat_tvidx1 - lat_tvidx0
    diff = diff+1
    if (lat_inc > 2): break

#Change "reduce_long_res" to reduce number of longitude cells and reduce or eliminate the number of blank cells in northern part of the plot. Suggest using values <= 1. 0 = no reduction (all cells shown)
reduce_long_res = 0
long_inc = long_inc+reduce_long_res

#calculate matrix size
maxlatix = int(round((northidx-southidx)/lat_inc))
maxlonix = int(round((westidx-eastidx)/long_inc))
tvfs=np.zeros((maxlonix,maxlatix))
tvsv=np.zeros((maxlonix,maxlatix))
print(maxlonix)
print(long_inc)
print(maxlatix)
print(lat_inc)



with open( "cellidx_data.txt", "r") as data:
  data.readline()
  data.readline()
  data.readline()
  data.readline()
  data.readline()
  for d in data:
    fields= d.strip().split(' ')
    lat_idx= maxlatix-int(int(fields[0])/lat_inc)
    lon_idx= maxlonix-int(int(fields[1])/long_inc)
    fs= int(round(float(fields[2])))
    sv= int(fields[3])
    if ((lat_idx < maxlatix) & (lon_idx < maxlatix)):
      tvfs[lat_idx,lon_idx]=fs
      tvsv[lat_idx,lon_idx]=sv
print ("Finished saving data to Numpy array")  
with open("tvfs.npy", 'wb') as np_data:
    np.save(np_data, tvfs)
with open("tvsv.npy", 'wb') as np_data:
    np.save(np_data, tvsv)    

def register_own_cmaps():
    cdict = {'red': ((0.0, 0.0, 0.0),
                     (0.005, 0.0, 0.0),
                     (0.2, 1.0, 1.0),
                     (0.3, 1.0, 1.0),
                     (0.4, 1.0, 1.0),
                     (0.5, 0.8, 0.8),
                     (0.6, 0.7, 0.7),
                     (0.7, 0.2, 0.2),
                     (0.8, 0.0, 0.0),
                     (1.0, 0.0, 0.0)),
         'green': ((0.0, 0.0, 0.0),
                   (0.005, 0.0, 0.0),
                   (0.2, 0.2, 0.2),
                   (0.3, 0.7, 0.7),
                   (0.4, 1.0, 1.0),
                   (0.5, 1.0, 1.0),
                   (0.6, 1.0, 1.0),
                   (0.7, 1.0, 1.0),
                   (0.8, 0.8, 0.8),
                   (1.0, 1.0, 1.0)),
         'blue': ((0.0, 0.0, 0.0),
                  (0.005, 0.0, 0.0),
                  (0.2, 0.0, 0.0),
                  (0.3, 0.0, 0.0),
                  (0.4, 0.0, 0.0),
                  (0.5, 0.0, 0.0),
                  (0.6, 0.0, 0.0),
                  (0.7, 0.0, 0.0),
                  (0.8, 0.5, 0.5), 
                  (1.0, 0.9, 0.9)),
         'alpha': ((0.0, 0.0, 0.0),
                  (0.005, 0.0, 1.0),
                  (0.2, 1.0, 1.0),
                  (0.3, 1.0, 1.0),
                  (0.4, 1.0, 1.0),
                  (0.5, 1.0, 1.0),
                  (0.6, 1.0, 1.0),
                  (0.7, 1.0, 1.0),
                  (0.8, 1.0, 1.0), 
                  (1.0, 1.0, 1.0))}
    cmap1 = col.LinearSegmentedColormap('my_colormap',cdict,N=256,gamma=0.75)
    cm.register_cmap(name='siglevel', cmap=cmap1)

register_own_cmaps()
# s = '{east}-{west}-{north}-{south}-{name}.png'
# overlay_file = s.format(east=str(lon_min_west),west=str(lon_max_west),north=str(lat_max_north),south=str(lat_min_north),name=npy_matrix_file)

imsave("tvfs.png", tvfs, cmap='siglevel', vmin=scale_min, vmax=scale_max)


c_offset = 0
c_res = 3600  # points per degree
kmz_file = "KVEA_real.kmz"
overlay_descrip = "KVEA real antenna pattern"
overlay_file = "tvfs.png"

south = (southidx+c_offset)/c_res
east = -(eastidx+c_offset)/c_res
north = (northidx+c_offset)/c_res
west = -(westidx+c_offset)/c_res

print(south)
print(east)
print(north)
print(west)

kml = simplekml.Kml()
ground = kml.newgroundoverlay(name=overlay_descrip)
ground.icon.href = overlay_file
# ground.gxlatlonquad.coords = [(west,south),(east,south),(east,north),(west,north)]
ground.latlonbox.south = south
ground.latlonbox.east = east
ground.latlonbox.north = north
ground.latlonbox.west = west
ground.latlonbox.rotation = 0
kml.savekmz(kmz_file)

		     

  
        
        
